; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
;																				
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
;	0 		1 	1 		8														
;	1 		0 	0 		16														
;	1 		0 	1	 	32														
; *	1 		1 	0 		64														
;	1 		1 	1 		128														
;																				
; ADC REFERENZ																	
; REFS1 REFS0 Voltage Reference Selection										
;  0     0    AREF, Internal Vref turned off									
;  0     1    AVCC with external capacitor at AREF pin							
; *1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin
;																				
ADC_INITIALISIERUNG:
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)) 
	out ADCSR, temp

	ldi temp, (1<<REFS1)|(1<<REFS0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-U																			
ADC_U:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -2			; KANAL 2				
	out ADMUX, temp
	rcall ADC_MESSEN		; OUT: TEMP1 / TEMP2	
;	ldi temp1,low (712)		; Testwert				
;	ldi temp2,high(712)
	STS(adr_ADC_U_L),temp1	; in SRAM speichern		
	STS(adr_ADC_U_H),temp2	; in SRAM speichern		
;-------------------------------------------------------------------------------
; mal Faktor																	
	ldi ZL,low (FAKTOR_U)	; Faktor			
	ldi ZH,high(FAKTOR_U)
	mov R1,temp1
	mov R2,temp2
	clr R3
	clr temp1				; Ergebnis clear	
	clr temp2
	clr temp3
;-------------------------------------------------------------------------------
ADC_U_s:
	add temp1,R1
	adc temp2,R2
	adc temp3,R3
	sbiw ZL,1				; Z-1				
	tst ZH
	brne ADC_U_s
	tst ZL
	brne ADC_U_s
;-------------------------------------------------------------------------------
; durch 256																		
	ldi ZL,low (128)		; aufrunden	halber Divisor addieren	
	ldi ZH,high(128)
	add temp1,ZL
	adc temp2,ZH
	mov temp1,temp2
	mov temp2,temp3
;-------------------------------------------------------------------------------
	ldi ZL,low (2)			; aufrunden	halber Divisor addieren	
	ldi ZH,high(2)
	add temp1,ZL
	adc temp2,ZH
	LSR temp2				; durch 2							
	ROR temp1
	LSR temp2				; durch 4							
	ROR temp1
	STS(adr_U),temp1		; save								
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-i																			
ADC_i:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -3			; KANAL 3
	out ADMUX, temp
	rcall ADC_MESSEN		; OUT: TEMP1 / TEMP2	
;	ldi temp1,low (389)		; Testwert				
;	ldi temp2,high(389)

	STS(adr_ADC_i_L),temp1	; in SRAM speichern		
	STS(adr_ADC_i_H),temp2	; in SRAM speichern		
;-------------------------------------------------------------------------------
; mal Faktor																	
	ldi ZL,low (FAKTOR_i)	; Faktor			
	ldi ZH,high(FAKTOR_i)
	mov R1,temp1
	mov R2,temp2
	clr R3
	clr temp1				; Ergebnis clear	
	clr temp2
	clr temp3
;-------------------------------------------------------------------------------
ADC_i_s:
	add temp1,R1
	adc temp2,R2
	adc temp3,R3
	sbiw ZL,1				; Z-1				
	tst ZH
	brne ADC_i_s
	tst ZL
	brne ADC_i_s
;-------------------------------------------------------------------------------
; durch 256																		
	ldi ZL,low (128)		; aufrunden	halber Divisor addieren	
	ldi ZH,high(128)
	add temp1,ZL
	adc temp2,ZH
	mov temp1,temp2
	mov temp2,temp3
;-------------------------------------------------------------------------------
	ldi ZL,low (2)			; aufrunden	halber Divisor addieren	
	ldi ZH,high(2)
	add temp1,ZL
	adc temp2,ZH
	LSR temp2				; durch 2				
	ROR temp1
	LSR temp2				; durch 4				
	ROR temp1
	STS(adr_i),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
ADC_MESSEN:
	clr temp3	; HILFSREGISTER CLEAR								
	clr temp4
	clr temp5
	clr temp6
	clr temp9	; SCHLEIFE initialisieren		
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal		
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_MESSEN_w:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt		
	rjmp ADC_MESSEN_w
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	(Schleife - 256 mal)									
ADC_MESSEN_s:                
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_MESSEN_w2:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt		
	rjmp ADC_MESSEN_w2
;-------------------------------------------------------------------------------
; ADC einlesen:																	
	in  temp1, ADCL 			; immer zuerst LOW Byte lesen
	in  temp2, ADCH 			; danach das mittlerweile gesperrte High Byte
;-------------------------------------------------------------------------------
; alle 256 ADC-Werte addieren													
	add temp4,temp1     		; addieren  						
	adc temp5,temp2     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
	dec temp9			 		; Schleifenzhler MINUS 1			
	brne ADC_MESSEN_s 			; ==> SCHLEIFE						
;-------------------------------------------------------------------------------
; MITTELWERT-BERECHNUNG	(128 addieren)											
	ldi temp,128
	add temp4,temp	     		; addieren  						
	adc temp5,NULL	     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
;-------------------------------------------------------------------------------
; 	Ergebnis durch 256 teilen (temp5+6 nach temp1+2 kopieren)					
	mov temp1,temp5
	mov temp2,temp6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
